#include<math.h>
#include<iostream>
using namespace std;
int sort(int x[],int n)
{
	for(int i=1;i<=n;i++)
	for(int j=i;j<=n-1;j++)
	if(x[j]>x[j+1])
	{
	int l=x[j];
	x[j]=x[j+1];
	x[j+1]=l;
	}	
}
main()
{
int T,N,M;
cin>>T;
int x[T];
for(int i=1;i<=T;i++)
{
cin>>N>>M;
int A[N];
for(int j=1;j<=N;j++)
cin>>A[j];
sort(A,N);
int B[M];
for(int j=1;j<=M;j++)
cin>>B[j];
int razlika=A[2]-A[1];
for(int j=2;j<=N-1;j++)
{
if((A[j+1]-A[j])<razlika)
razlika=A[j+1]-A[j];
}
int provera=0;
for(int j=2;j<=N-1;j++)
{
if((A[j+1]-A[j])%razlika!=0)
{
j=N-1;
provera=1;
}
}
if(provera==0)
{
for(int l=1;l<=M;l++)
{
if((B[M]-A[1])%razlika==0)
{
l=M;
provera=1;
}
}
}
if(provera==1)
x[i]=0;
else x[i]=1;
}
for(int i=1;i<=T;i++)
cout<<x[i]<<endl;
}